// TestAppDlg.cpp : implementation file
//
using namespace System;
using namespace System::Text;


#include "stdafx.h"
#include "TestApp.h"
#include "TestAppDlg.h"
#include "ConnectDlg.h"
#include "StringDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CTestAppDlg dialog

CTestAppDlg::CTestAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestAppDlg::IDD, pParent)
	, m_Edit(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bMySQLMobileReady = fnLoadMySQLMobileFunctions();
}

CTestAppDlg::~CTestAppDlg()
{
	if (m_hMySQLMobileDll)
		FreeLibrary(m_hMySQLMobileDll);
}


void CTestAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_Edit);
}

BEGIN_MESSAGE_MAP(CTestAppDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_CONNECTBTN, &CTestAppDlg::OnBnClickedConnectbtn)
	ON_BN_CLICKED(IDC_DISCONNBTN, &CTestAppDlg::OnBnClickedDisconnbtn)
	ON_BN_CLICKED(IDC_SELECTDBBTN, &CTestAppDlg::OnBnClickedSelectdbbtn)
	ON_BN_CLICKED(IDC_EXECBTN, &CTestAppDlg::OnBnClickedExecbtn)
	ON_BN_CLICKED(IDC_SHOWRESULTSBTN, &CTestAppDlg::OnBnClickedShowresultsbtn)
END_MESSAGE_MAP()


// CTestAppDlg message handlers

BOOL CTestAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CTestAppDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	DRA::RelayoutDialog(
		AfxGetInstanceHandle(),
		this->m_hWnd,
		DRA::GetDisplayMode() != DRA::Portrait ?
			MAKEINTRESOURCE(IDD_TESTAPP_DIALOG_WIDE) :
			MAKEINTRESOURCE(IDD_TESTAPP_DIALOG));
}
#endif


BOOL CTestAppDlg::fnLoadMySQLMobileFunctions()
{
BOOL bRet = TRUE;

	m_hMySQLMobileDll = LoadLibrary(_T("MySQLMobile.dll"));
	if (m_hMySQLMobileDll) {
		mysql_enable_compression		= (mysql_enable_compression_Proc)		GetProcAddress( m_hMySQLMobileDll, _T("mysql_enable_compression"));
		mysql_connect					= (mysql_connect_Proc)					GetProcAddress( m_hMySQLMobileDll, _T("mysql_connect"));
		mysql_disconnect				= (mysql_disconnect_Proc)				GetProcAddress( m_hMySQLMobileDll, _T("mysql_disconnect"));
		mysql_select_db					= (mysql_select_db_Proc)				GetProcAddress( m_hMySQLMobileDll, _T("mysql_select_db"));
		mysql_execute_query				= (mysql_execute_query_Proc)			GetProcAddress( m_hMySQLMobileDll, _T("mysql_execute_query"));
		mysql_get_last_error			= (mysql_get_last_error_Proc)			GetProcAddress( m_hMySQLMobileDll, _T("mysql_get_last_error"));
		mysql_get_last_insert_id		= (mysql_get_last_insert_id_Proc)		GetProcAddress( m_hMySQLMobileDll, _T("mysql_get_last_insert_id"));
		mysql_get_last_servermessage	= (mysql_get_last_servermessage_Proc)	GetProcAddress( m_hMySQLMobileDll, _T("mysql_get_last_servermessage"));
		mysql_get_fieldcount			= (mysql_get_fieldcount_Proc)			GetProcAddress( m_hMySQLMobileDll, _T("mysql_get_fieldcount"));
		mysql_get_field					= (mysql_get_field_Proc)				GetProcAddress( m_hMySQLMobileDll, _T("mysql_get_field"));
		mysql_get_rowcount				= (mysql_get_rowcount_Proc)				GetProcAddress( m_hMySQLMobileDll, _T("mysql_get_rowcount"));
		mysql_get_data					= (mysql_get_data_Proc)					GetProcAddress( m_hMySQLMobileDll, _T("mysql_get_data"));

		if ((mysql_enable_compression == NULL) ||
			(mysql_connect == NULL) ||
			(mysql_disconnect == NULL) ||
			(mysql_select_db == NULL) ||
			(mysql_execute_query == NULL) ||
			(mysql_get_last_error == NULL) ||
			(mysql_get_last_insert_id == NULL) ||
			(mysql_get_last_servermessage == NULL) ||
			(mysql_get_fieldcount == NULL) ||
			(mysql_get_field == NULL) ||
			(mysql_get_rowcount == NULL) ||
			(mysql_get_data == NULL)) {
			bRet = FALSE;
		}
	} else {
		bRet = FALSE;
	}
	return bRet;
}

void CTestAppDlg::fnAddMessage(CString str)
{
	m_Edit += (str + _T("\r\n"));
	UpdateData(FALSE);
}

void CTestAppDlg::OnBnClickedConnectbtn()
{
	if (!m_bMySQLMobileReady) {
		fnAddMessage(_T("MySQLMobile is not ready for usage..."));
		return;
	}

	CConnectDlg dlg;
	if (dlg.DoModal() == IDOK) {
		char *host = GetAnsiString(dlg.m_Host);
		char *username = GetAnsiString(dlg.m_Username);
		char *password = GetAnsiString(dlg.m_Password);
		int nRet = mysql_connect(host, dlg.m_nPort, username, password);
		delete host;
		delete username;
		delete password;

		if (nRet == 0) {
			fnAddMessage(_T("mysql_connect() successful"));
		} else {
			char *errorBuf = new char[255];
			mysql_get_last_error(nRet, errorBuf);
			fnAddMessage(CString(errorBuf));
			delete errorBuf;
		}
	}
}

char* CTestAppDlg::GetAnsiString(const CString &s)
{
	int nSize = s.GetLength();
	char *pAnsiString = new char[nSize+1];
	wcstombs(pAnsiString, s, nSize+1);
	return pAnsiString;
}


void CTestAppDlg::OnBnClickedDisconnbtn()
{
	if (!m_bMySQLMobileReady) {
		fnAddMessage(_T("MySQLMobile is not ready for usage..."));
		return;
	}

	int nRet = mysql_disconnect();
	if (nRet == 0) {
		fnAddMessage(_T("mysql_disconnect() successful"));
	} else {
		char *errorBuf = new char[255];
		mysql_get_last_error(nRet, errorBuf);
		fnAddMessage(CString(errorBuf));
		delete errorBuf;
	}
}

void CTestAppDlg::OnBnClickedSelectdbbtn()
{
	if (!m_bMySQLMobileReady) {
		fnAddMessage(_T("MySQLMobile is not ready for usage..."));
		return;
	}

	CStringDlg dlg;
	dlg.SetTitle(_T("Enter database name:"));
	if (dlg.DoModal() == IDOK) {
		char *db = GetAnsiString(dlg.m_String);
		int nRet = mysql_select_db(db);
		delete db;

		if (nRet == 0) {
			fnAddMessage(_T("mysql_select_db() successful"));
		} else {
			char *errorBuf = new char[255];
			mysql_get_last_error(nRet, errorBuf);
			fnAddMessage(CString(errorBuf));
			delete errorBuf;
		}
	}
}

void CTestAppDlg::OnBnClickedExecbtn()
{
	if (!m_bMySQLMobileReady) {
		fnAddMessage(_T("MySQLMobile is not ready for usage..."));
		return;
	}

	CStringDlg dlg;
	dlg.SetTitle(_T("Enter query (we recommend that you use the LIMIT keyword in SELECT queries)"));
	if (dlg.DoModal() == IDOK) {
		char *query = GetAnsiString(dlg.m_String);
		int nRet = mysql_execute_query(query);
		delete query;

		if (nRet == 0) {
			fnAddMessage(_T("mysql_execute_query() successful"));
		} else {
			char *errorBuf = new char[255];
			mysql_get_last_error(nRet, errorBuf);
			fnAddMessage(CString(errorBuf));
			delete errorBuf;
		}
	}
}

void CTestAppDlg::OnBnClickedShowresultsbtn()
{
	if (!m_bMySQLMobileReady) {
		fnAddMessage(_T("MySQLMobile is not ready for usage..."));
		return;
	}

	int nRet;
	CString str;
	char *errorBuf = new char[255];

	// get field names
	char* fieldname_buffer = new char[255];
	int int_buffer;
	str = _T("");
	for (int i=0; i < mysql_get_fieldcount(); i++) {
		nRet = mysql_get_field(fieldname_buffer, int_buffer, FIELD_PARAM_FIELD, i);
		if (nRet == 0) {
			str += (_T("[") + CString(fieldname_buffer) + _T("] "));
		} else {
			mysql_get_last_error(nRet, errorBuf);
			fnAddMessage(CString(errorBuf));
		}
	}
	delete fieldname_buffer;

	fnAddMessage(_T("fields: ") + str);

	// get data
	char* data_buffer = new char[8192]; // max data size = 8K
	str = _T("");
	for (int i=0; i < mysql_get_rowcount(); i++) {
		for (int j=0; j < mysql_get_fieldcount(); j++) {
			nRet = mysql_get_data(data_buffer, i, j);
			if (nRet == 0) {
				str += (_T("[") + CString(data_buffer) + _T("] "));
			} else {
				mysql_get_last_error(nRet, errorBuf);
				fnAddMessage(CString(errorBuf));
			}
		}
		fnAddMessage(_T("row: ") + str);
		str = _T("");
	}
	delete data_buffer;
	delete errorBuf;
}
